package com.kdanmobile.kdanloginregisterui.screen

import com.kdanmobile.kdanloginregisterui.Utils.toSpannable

import android.support.v7.app.AppCompatActivity
import android.text.method.LinkMovementMethod
import android.view.View
import android.widget.TextView
import com.kdanmobile.kdanloginregisterui.R

open class BaseLoginActivity : AppCompatActivity() {
    protected var email: String = ""
    protected var pwd: String = ""
    protected var isRemember: Boolean = false

    protected open fun onEmailLogin(email: String, pwd: String, isRemember: Boolean) { }
    protected open fun onClickFbLoginBtn(view: View?) { }
    protected open fun onClickGoogleLoginBtn(view: View?) {}
    protected open fun onClickTurnOfService(view: View?) { }
    protected open fun onClickPrivacyPolicy(view: View?) { }
    protected open fun onClickSwitchToRegister(view: View?) { }
    protected open fun onClickPwdHelp(view: View?) {}
    protected open fun onClickCloseBtn(view: View?) { }

    protected fun setupTosAndPpTextView(textView: TextView) {
        val tos = getString(R.string.terms_of_service)
        val pp = getString(R.string.privacy_policy)
        val textColor = resources.getColor(R.color.tos_pp_text)
        val tosSS = tos.toSpannable(textColor, false, View.OnClickListener { v -> onClickTurnOfService(v) })
        val ppSS = pp.toSpannable(textColor, false, View.OnClickListener { v -> onClickPrivacyPolicy(v) })
        textView.apply {
            movementMethod = LinkMovementMethod.getInstance()
            append(tosSS)
            append(" & ")
            append(ppSS)
        }
    }

    protected fun setupSwitchTextView(textView: TextView) {
        val s = textView.text
        val textColor = resources.getColor(R.color.switch_text)
        val ss = s.toSpannable(textColor, true, View.OnClickListener { v -> onClickSwitchToRegister(v) })
        textView.apply {
            movementMethod = LinkMovementMethod.getInstance()
            text = ss
        }
    }
}