package com.kdanmobile.kdanloginregisterui.screen

import com.kdanmobile.kdanloginregisterui.Utils.toSpannable

import android.support.v7.app.AppCompatActivity
import android.text.method.LinkMovementMethod
import android.view.View
import android.widget.TextView
import com.kdanmobile.kdanloginregisterui.R

open class BaseRegisterActivity : AppCompatActivity() {

    protected open fun onEmailRegister(name: String, email: String, pwd: String) { }
    protected open fun onClickFbRegisterBtn(view: View?) { }
    protected open fun onClickGoogleRegisterBtn(view: View?) {}
    protected open fun onClickTurnOfService(view: View?) { }
    protected open fun onClickPrivacyPolicy(view: View?) { }
    protected open fun onClickSwitchToLogin(view: View?) { }
    protected open fun onClickCloseBtn(view: View?) { }

    protected fun setupSwitchTextView(textView: TextView) {
        val s = textView.text
        val textColor = resources.getColor(R.color.switch_text)
        val ss = s.toSpannable(textColor, true, View.OnClickListener { v -> onClickSwitchToLogin(v) })
        textView.apply {
            movementMethod = LinkMovementMethod.getInstance()
            text = ss
        }
    }

    protected fun setupTosAndPpTextView(textView: TextView) {
        try {
            val key = "[d*_*b]"
            val tos = getString(R.string.terms_of_service)
            val pp = getString(R.string.privacy_policy)
            val pattern = getString(R.string.register_tos_and_pp_pattern, key, key)
            val stringArray = pattern.split(key)
            val textColor = resources.getColor(R.color.tos_pp_text)
            val tosSS = tos.toSpannable(textColor, false, View.OnClickListener { v -> onClickTurnOfService(v) })
            val ppSS = pp.toSpannable(textColor, false, View.OnClickListener { v -> onClickPrivacyPolicy(v) })
            textView.apply {
                movementMethod = LinkMovementMethod.getInstance()
                append(stringArray[0])
                append(tosSS)
                append(stringArray[1])
                append(ppSS)
                append(stringArray[2])
            }
        } catch (e: Exception) {
            // do nothing, let it go ~
        }
    }

}