package com.kdanmobile.kdanloginregisterui.screen

import android.support.v7.app.AppCompatActivity
import android.os.Bundle
import android.text.TextUtils
import android.view.View
import android.widget.Toast
import com.kdanmobile.kdanloginregisterui.R
import kotlinx.android.synthetic.main.activity_bind_account.*
import org.apache.commons.validator.routines.EmailValidator

open class BindAccountActivity : AppCompatActivity() {

    protected var email: String
        get() = et_bindAccount_email.text.toString()
        set(value) {}
    protected var pwd: String
        get() = et_bindAccount_pwd.text.toString()
        set(value) {}

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_bind_account)
        setThirdPtyName("Google")
        btn_bindAccount_back.setOnClickListener { onClickBackBtn(it) }
        btn_bindAccount_create.setOnClickListener { onClickCreateBtn(it) }
        btn_bindAccount_bind.setOnClickListener { onClickConnectBtn() }
    }

    protected open fun onConnect(email: String, pwd: String) {
        val msg = """
            email: $email
            pwd: $pwd
        """.trimIndent()
        Toast.makeText(this, msg, Toast.LENGTH_LONG).show()
    }

    protected open fun onClickCreateBtn(view: View) {
        Toast.makeText(this, "on click create", Toast.LENGTH_LONG).show()
    }

    protected open fun onClickBackBtn(view: View) {
        Toast.makeText(this, "on back", Toast.LENGTH_LONG).show()
    }

    protected fun setThirdPtyName(name: String) {
        tv_bindAccount_createNew.text = getString(R.string.bind_account_create_new_text, name)
        tv_bindAccount_bind.text = getString(R.string.bind_account_bind_text, name)
        tv_bindAccount_bindExplanation.text = getString(R.string.bind_account_bind_explanation, name)
    }

    private fun onClickConnectBtn() {
        val isEmailValid = !TextUtils.isEmpty(email) && EmailValidator.getInstance().isValid(email)
        val isPwdValid = !TextUtils.isEmpty(pwd)
        et_bindAccount_email.error = when {
            isEmailValid -> null
            else -> getString(R.string.email_login_register_dialog_email_error)
        }
        et_bindAccount_pwd.error = when {
            isPwdValid -> null
            else -> getString(R.string.email_login_register_dialog_pwd_error)
        }
        if (isEmailValid && isPwdValid) {
            onConnect(email, pwd)
        }
    }
}
