package com.kdanmobile.kdanloginregisterui.screen

import android.content.Intent
import android.os.Bundle
import android.view.View
import android.widget.Toast
import com.kdanmobile.kdanloginregisterui.R
import kotlinx.android.synthetic.main.activity_login_a.*

open class LoginAActivity : BaseLoginActivity() {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_login_a)
        setupTosAndPpTextView(tv_loginA_tosAndPp)
        setupSwitchTextView(tv_loginA_switchToRegister)
        setupFormView()
        view_loginA_fbLogin.setOnClickListener { onClickFbLoginBtn(it) }
        view_loginA_googleLogin.setOnClickListener { onClickGoogleLoginBtn(it) }
        btn_loginA_close.setOnClickListener { onClickCloseBtn(it) }
    }

    private fun setupFormView() {
        emailLoginFromView_loginA.let {
            it.isRemember = isRemember
            it.email = email
            it.pwd = pwd
            it.onClickPwdHelp = View.OnClickListener { onClickPwdHelp(it) }
            it.onSubmit = Runnable { onEmailLogin(it.email, it.pwd, it.isRemember) }
        }
    }

    override fun onEmailLogin(email: String, pwd: String, isRemember: Boolean) {
        val msg = """
            email: $email
            wpd: $pwd
            isRemember: $isRemember
        """.trimIndent()
        Toast.makeText(this, msg, Toast.LENGTH_LONG).show()
    }

    override fun onClickFbLoginBtn(view: View?) {
        Toast.makeText(this, "on fb login", Toast.LENGTH_LONG).show()
    }

    override fun onClickGoogleLoginBtn(view: View?) {
        Toast.makeText(this, "on google login", Toast.LENGTH_LONG).show()
    }

    override fun onClickTurnOfService(view: View?) {
        Toast.makeText(this, "on click tos", Toast.LENGTH_LONG).show()
    }

    override fun onClickPrivacyPolicy(view: View?) {
        Toast.makeText(this, "on click pp", Toast.LENGTH_LONG).show()
    }

    override fun onClickSwitchToRegister(view: View?) {
        val intent = Intent(this, RegisterAActivity::class.java)
        startActivity(intent)
    }

    override fun onClickPwdHelp(view: View?) {
        Toast.makeText(this, "on click pwd help", Toast.LENGTH_LONG).show()
    }

    override fun onClickCloseBtn(view: View?) {
        finish()
    }
}
