package com.kdanmobile.kdanloginregisterui.screen

import android.content.Intent
import android.os.Bundle
import android.support.v7.app.AlertDialog
import android.view.LayoutInflater
import android.view.View
import android.widget.Toast
import com.kdanmobile.kdanloginregisterui.R
import com.kdanmobile.kdanloginregisterui.widget.EmailLoginFormView
import kotlinx.android.synthetic.main.activity_login_b.*

open class LoginBActivity : BaseLoginActivity() {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_login_b)
        setupTosAndPpTextView(tv_loginB_tosAndPp)
        setupSwitchTextView(tv_loginB_switchToRegister)
        setupEmailLoginBtn()
        view_loginB_fbLogin.setOnClickListener { onClickFbLoginBtn(it) }
        view_loginB_googleLogin.setOnClickListener { onClickGoogleLoginBtn(it) }
        btn_loginB_close.setOnClickListener { onClickCloseBtn(it) }
    }

    override fun onEmailLogin(email: String, pwd: String, isRemember: Boolean) {
        val msg = """
            email: $email
            pwd: $pwd
            isRemember: $isRemember
        """.trimIndent()
        Toast.makeText(this, msg, Toast.LENGTH_LONG).show()
    }

    override fun onClickFbLoginBtn(view: View?) {
        Toast.makeText(this, "on fb login", Toast.LENGTH_LONG).show()
    }

    override fun onClickGoogleLoginBtn(view: View?) {
        Toast.makeText(this, "on google login", Toast.LENGTH_LONG).show()
    }

    override fun onClickTurnOfService(view: View?) {
        Toast.makeText(this, "on click tos", Toast.LENGTH_LONG).show()
    }

    override fun onClickPrivacyPolicy(view: View?) {
        Toast.makeText(this, "on click pp", Toast.LENGTH_LONG).show()
    }

    override fun onClickPwdHelp(view: View?) {
        Toast.makeText(this, "on click pwd help", Toast.LENGTH_LONG).show()
    }

    override fun onClickCloseBtn(view: View?) {
        finish()
    }

    override fun onClickSwitchToRegister(view: View?) {
        val intent = Intent(this, RegisterBActivity::class.java)
        startActivity(intent)
        finish()
    }

    private fun setupEmailLoginBtn() {
        view_loginB_emailLogin.setOnClickListener {
            val context = this
            val view = LayoutInflater.from(context).inflate(R.layout.dialog_email_login, null)
            val formView = view.findViewById<EmailLoginFormView>(R.id.formView_emailLoginDialog)
            val dialog = AlertDialog.Builder(context).setView(view).show()
            formView.let {
                it.isRemember = isRemember
                it.email = email
                it.pwd = pwd
                it.onSubmit = Runnable {
                    onEmailLogin(it.email, it.pwd, it.isRemember)
                    dialog.dismiss()
                }
                it.onClickPwdHelp = View.OnClickListener { onClickPwdHelp(it) }
            }
        }
    }
}
