package com.kdanmobile.kdanloginregisterui.screen

import android.content.Intent
import android.os.Bundle
import android.view.View
import android.widget.Toast
import com.kdanmobile.kdanloginregisterui.R
import kotlinx.android.synthetic.main.activity_register_a.*

open class RegisterAActivity : BaseRegisterActivity() {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_register_a)
        setupSwitchTextView(tv_registerA_switchToLogin)
        setupTosAndPpTextView(tv_registerA_tosAndPp)
        emailRegisterFromView_registerA.apply {
            onSubmit = Runnable { onEmailRegister(name, email, pwd) }
        }
        view_registerA_fbRegister.setOnClickListener { onClickFbRegisterBtn(it) }
        view_registerA_googleRegister.setOnClickListener { onClickGoogleRegisterBtn(it) }
    }

    override fun onEmailRegister(name: String, email: String, pwd: String) {
        val msg = """
            name: $name
            email: $email
            pwd: $pwd
        """.trimIndent()
        Toast.makeText(this, msg, Toast.LENGTH_LONG).show()
    }

    override fun onClickFbRegisterBtn(view: View?) {
        Toast.makeText(this, "on fb register", Toast.LENGTH_LONG).show()
    }

    override fun onClickGoogleRegisterBtn(view: View?) {
        Toast.makeText(this, "on google register", Toast.LENGTH_LONG).show()
    }

    override fun onClickTurnOfService(view: View?) {
        Toast.makeText(this, "on click tos", Toast.LENGTH_LONG).show()
    }

    override fun onClickPrivacyPolicy(view: View?) {
        Toast.makeText(this, "on click pp", Toast.LENGTH_LONG).show()
    }

    override fun onClickSwitchToLogin(view: View?) {
        val intent = Intent(this, LoginAActivity::class.java)
        startActivity(intent)
    }

    override fun onClickCloseBtn(view: View?) {
        finish()
    }
}
