package com.kdanmobile.kdanloginregisterui.screen

import android.content.Intent
import android.os.Bundle
import android.support.v7.app.AlertDialog
import android.view.LayoutInflater
import android.view.View
import android.widget.Toast
import com.kdanmobile.kdanloginregisterui.R
import com.kdanmobile.kdanloginregisterui.widget.EmailRegisterFormView
import kotlinx.android.synthetic.main.activity_register_b.*

open class RegisterBActivity : BaseRegisterActivity() {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_register_b)
        setupSwitchTextView(tv_registerB_switchToLogin)
        setupTosAndPpTextView(tv_registerB_tosAndPp)
        setupEmailRegisterBtn()
        view_registerB_fbRegister.setOnClickListener { onClickFbRegisterBtn(it) }
        view_registerB_googleRegister.setOnClickListener { onClickGoogleRegisterBtn(it) }
        btn_registerB_close.setOnClickListener { onClickCloseBtn(it) }
    }

    override fun onEmailRegister(name: String, email: String, pwd: String) {
        val msg = """
            name: $name
            email: $email
            pwd: $pwd
        """.trimIndent()
        Toast.makeText(this, msg, Toast.LENGTH_LONG).show()
    }

    override fun onClickFbRegisterBtn(view: View?) {
        Toast.makeText(this, "on fb register", Toast.LENGTH_LONG).show()
    }

    override fun onClickGoogleRegisterBtn(view: View?) {
        Toast.makeText(this, "on google register", Toast.LENGTH_LONG).show()
    }

    override fun onClickTurnOfService(view: View?) {
        Toast.makeText(this, "on click tos", Toast.LENGTH_LONG).show()
    }

    override fun onClickPrivacyPolicy(view: View?) {
        Toast.makeText(this, "on click pp", Toast.LENGTH_LONG).show()
    }

    override fun onClickCloseBtn(view: View?) {
        finish()
    }

    override fun onClickSwitchToLogin(view: View?) {
        val intent = Intent(this, LoginBActivity::class.java)
        startActivity(intent)
        finish()
    }

    private fun setupEmailRegisterBtn() {
        view_registerB_emailRegister.setOnClickListener {
            val context = this
            val view = LayoutInflater.from(context).inflate(R.layout.dialog_email_register, null)
            val formView = view.findViewById<EmailRegisterFormView>(R.id.formView_emailRegisterDialog)
            val dialog = AlertDialog.Builder(context).setView(view).show()
            formView.let {
                it.onSubmit = Runnable {
                    onEmailRegister(it.name, it.email, it.pwd)
                    dialog.dismiss()
                }
            }
        }
    }
}
